package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10054DealerResult;
import cn.net.cpzslibs.prot.handset.bean.Prot10054DealerResultBean;
import cn.net.cpzslibs.prot.handset.bean.Prot10054SendDealerBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10054GetDealer extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;

	private final short iTaskCode10054 = 10054;
	private Gson gson;
	private Prot10054DealerResult res;
	private List<Prot10054DealerResultBean> dealerData = new ArrayList<>();
	private boolean isEnd = false;// true：所有协议包已经请求完 false：服务器返回的数据还未接收完全

	public Prot10054GetDealer() {

		gson = new Gson();
	}

	public Prot10054DealerResult getRes() {
		return res;
	}

	public void setRes(Prot10054DealerResult res) {
		this.res = res;
	}

	public void dealGetDealer(SocketCreate create,
			Prot10054SendDealerBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10054SendDealerBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10054, "开始请求产品列表");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				while (!isEnd) {
					recDealer(dis);
				}
			}
		}
	}

	static int cTest = 0;

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recDealer(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10054, (cTest++) + "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10054, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			res = gson.fromJson(jsonData, Prot10054DealerResult.class);
			if (res.getList() != null) {
				dealerData.addAll(res.getList());
			}
			if (res.getIndex() == 0) {
				res.setList(dealerData);
				isEnd = true;
			}
			if(res.getiResult()!=0){//请求失败
				isEnd = true;
			}
		}else {
			isEnd = true;
		}
		recCheckCode(dis);
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10054SendDealerBean reqBean)
			throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10054, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		// sendCheckCode(dos);
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}
